<?php

namespace OrganizationsManagement\Factory;

use OrganizationsManagement\Util\InstanceProvider;
use Teknisa\Model\Teknisa\Entities\OmColetaMedidaVariavel;
use Teknisa\Model\Services\Entities\FctTipomedidaserv;
use Teknisa\Model\Util\NovoCodigo;

class ColetaMedidaVariavel {
    /**
     * @param OmColetaMedidaVariavel|null $entity
     * @param $qtddiasaviso
     * @param $qtddiasreaplicar
     * @param $idativo
     * @param $phpscriptcount
     * @param $phpscriptlog
     * @param $cdtpmedidaserv
     * @param $cdservorca
     * @return OmConfigMedidaVariavel|OmColetaMedidaVariavel
     * @throws \Exception
     */
    public function save(OmColetaMedidaVariavel $entity = null, $qtddiasaviso, $qtddiasreaplicar, $idativo, 
                         $phpscriptcount, $phpscriptlog, $cdtpmedidaserv, $cdservorca, $idTpScript) {
        $environment     = InstanceProvider::getEnvironment();
        $currentOperator = $environment->getCurrentUserId();
        $currentNrorg    = $environment->getCurrentOrganizationId();
        $dtAtual         = new \DateTime();

        if(!$entity) {
            $entity  = new OmColetaMedidaVariavel();
            $newCode = NovoCodigo::geraCodigo($currentNrorg, "OmColetaMedidaVariavel", 1, 10, false, false);
            $entity->setId($newCode);
            $entity->setDtinclusao($dtAtual);
            $entity->setCdoperinclusao($currentOperator);
            $entity->setNrorginclusao($currentNrorg);
        }

        $entity->setDtultatu($dtAtual);
        $entity->setCdoperultatu($currentOperator);
        $entity->setNrorgultatu($currentNrorg);

        $entity->setNrorg($currentNrorg);
        $entity->setIdativo($idativo);
        $entity->setCdtpmedidaserv($cdtpmedidaserv);
        $entity->setPhpScriptLog($phpscriptlog);
        $entity->setPhpScriptCount($phpscriptcount);
        $entity->setQtdDiasAviso($qtddiasaviso);
        $entity->setQtdDiasReaplicar($qtddiasreaplicar);
        $entity->setCdservorca($cdservorca);
        $entity->setIdtpscript($idTpScript);

        return $entity;
    }
}