<?php
namespace OrganizationsManagement\Factory;

use Teknisa\Model\Teknisa\Entities\OmProduto as EntidadeOmProduto;
use Teknisa\Model\Teknisa\Entities\OmProdutoColetor as EntidadeOmProdutoColetor;
use Teknisa\Model\Geral\Entities\Produto as EntidadeProduto;
use Teknisa\Libs\Util\Environment as TeknisaEnvironment;
use Setforms2\Shared\ORM\DateTime as SetformsDateTime;
use Teknisa\Model\Util\NovoCodigo as NovoCodigo;

class Produto {
    /** @var TeknisaEnvironment **/
    protected $environment;

    public function __construct(TeknisaEnvironment $environment){
        $this->environment = $environment;
    }

    public function updateProduto(EntidadeProduto $e, $projectId = null, $cdProdcomp = null, $cdProdgrup = null){
        $e->setCdprodcomp($cdProdcomp);
        $e->setCdprodgrup($cdProdgrup);
        $e->setProjectId($projectId);
        return $e;
    }
    
    public function cria($id, $nome, $nrexternalorg, $nrexternalProductId, $idstatus){
        $e = new EntidadeOmProduto();
        
        $e->setId($id);
        $e->setNmproduto($nome);
        $e->setNrexternalorg($nrexternalorg);
        $e->setNrexternalProductId($nrexternalProductId);
        $e->setIdstatus($idstatus);

        $organizacaoLogada = $this->environment->getCurrentOrganizationId();
        $operadorLogado = $this->environment->getCurrentUserId();
        $e->setNrorg($organizacaoLogada);
        $e->setNrorgultatu($organizacaoLogada);
        $e->setNrorginclusao($organizacaoLogada);
        $e->setCdoperinclusao($operadorLogado);
        $e->setCdoperultatu($operadorLogado);

        $e->setDtinclusao(new SetformsDateTime());
        $e->setDtultatu(new SetformsDateTime());
        
        return $e;
    }

    public function saveProductCollector(EntidadeOmProdutoColetor $collector = null, $currentOrgId, $codOperador, $dateNow,
                         $idColetor, $dsStringConexao, $idUtWallet, $dsUsuarioBanco, $dsSenhaBanco, $idativo, $nrProdutoId, $idTpBanco)
    {
        if ($collector === null) {
            $novoCodigo = NovoCodigo::geraCodigo($currentOrgId, "OM_PRODUTO_COLETOR", 1, 10, false, false);
            $collector = new EntidadeOmProdutoColetor();
            $collector->setId($novoCodigo);
            $collector->setCdoperinclusao($codOperador);
            $collector->setNrorginclusao($currentOrgId);
            $collector->setDtinclusao($dateNow);
            $collector->setNrorg($currentOrgId);
        }
        
        $collector->setCdoperultatu($codOperador);
        $collector->setNrorgultatu($currentOrgId);
        $collector->setDtultatu($dateNow);
        
        $collector->setIdativo($idativo);
        $collector->setNrprodutoId($nrProdutoId);
        $collector->setIdcoletor($idColetor);
        $collector->setDsstringconexao($dsStringConexao);
        $collector->setIdutwallet($idUtWallet);
        $collector->setDsusuariobanco($dsUsuarioBanco);
        $collector->setDssenhabanco($dsSenhaBanco);
        $collector->setIdtpbanco($idTpBanco);
        
        return $collector;
    }
}