/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_INSPECAO                                                 */
/* Tabela : INSPECAO                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_INSPECAO'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_INSPECAO
GO

CREATE TRIGGER DTULTATU_INSPECAO
ON INSPECAO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'INSPECAO', null, 'CDNVINSPECAO='+ CDNVINSPECAO+ ';'+
                                       'CDARVINSPEC=' + CDARVINSPEC + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE INSPECAO
      SET DTULTATUINSP = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(INSPECAO.CDINSPECAO,0)   = ISNULL(INSERTED.CDINSPECAO,0))   AND
            (ISNULL(INSPECAO.CDARVINSPEC,0)  = ISNULL(INSERTED.CDARVINSPEC,0))  AND
            (ISNULL(INSPECAO.NMINSPECAO,0)   = ISNULL(INSERTED.NMINSPECAO,0))   AND
            (ISNULL(INSPECAO.CDNVINSPECAO,0) = ISNULL(INSERTED.CDNVINSPECAO,0)) AND
            (ISNULL(INSPECAO.IDORIGINSPEC,0) = ISNULL(INSERTED.IDORIGINSPEC,0));
   END;
END;
GO

